import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:okane/ui/state/core.dart';
import 'package:okane/ui/widgets/image_wrapper.dart';

class BeneficiaryListPage extends StatelessWidget {
  const BeneficiaryListPage({super.key});

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<CoreCubit, CoreState>(
      builder: (context, state) {
        return Stack(
          children: [
            ListView.builder(
              itemCount: state.beneficiaries.length,
              itemBuilder: (context, index) {
                final item = state.beneficiaries[index];
                return ListTile(
                  leading: ImageWrapper(title: item.name, path: item.imagePath),
                  // TODO: Allow deleting beneficiaries
                  trailing: IconButton(
                    onPressed: null,
                    icon: Icon(Icons.delete, color: Colors.grey),
                  ),
                  title: Text(item.name),
                );
              },
            ),
          ],
        );
      },
    );
  }
}
